org.apache.calcite.avatica.remote

## Class Driver

- java.lang.Object
- - org.apache.calcite.avatica.UnregisteredDriver
  - - org.apache.calcite.avatica.remote.Driver

All Implemented Interfaces:
  Driver

    public class Driver
    extends UnregisteredDriver

Avatica Remote JDBC driver.

### Nested Class Summary

Nested Classes
`static class` `Driver.Serialization` Defines the method of message serialization used by the Driver

### Nested classes/interfaces inherited from class org.apache.calcite.avatica.UnregisteredDriver

`UnregisteredDriver.JdbcVersion`

### Field Summary

Fields
`static String` `CONNECT_STRING_PREFIX`
`private static org.slf4j.Logger` `LOG`

### Fields inherited from class org.apache.calcite.avatica.UnregisteredDriver

`factory, handler`

### Constructor Summary

Constructors
Constructor and Description
`Driver()`

### Method Summary

All Methods Instance Methods Concrete Methods
`Connection` `connect(String url, Properties info)`
`protected DriverVersion` `createDriverVersion()` Creates an object describing the name and version of this driver.
`(package private) KerberosConnection` `createKerberosUtility(ConnectionConfig config)`
`Meta` `createMeta(AvaticaConnection connection)` Creates a service handler that will give connections from this Driver their behavior.
`(package private) Service` `createService(AvaticaConnection connection, ConnectionConfig config)` Creates a `Service` with the given `AvaticaConnection` and configuration.
`protected Collection<ConnectionProperty>` `getConnectionProperties()` Returns the connection properties supported by this driver.
`protected String` `getConnectStringPrefix()` Returns the prefix of the connect string that this driver will recognize as its own.
`(package private) AvaticaHttpClient` `getHttpClient(AvaticaConnection connection, ConnectionConfig config)` Creates the HTTP client that communicates with the Avatica server.
`(package private) Driver.Serialization` `getSerialization(ConnectionConfig config)`

### Methods inherited from class org.apache.calcite.avatica.UnregisteredDriver

`acceptsURL, createFactory, createHandler, getDriverVersion, getFactoryClassName, getMajorVersion, getMinorVersion, getParentLogger, getPropertyInfo, instantiateFactory, jdbcCompliant, register`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### LOG

    private static final org.slf4j.Logger LOG

#### CONNECT_STRING_PREFIX

    public static final String CONNECT_STRING_PREFIX

See Also:
  Constant Field Values

### Constructor Detail

#### Driver

    public Driver()

### Method Detail

#### getConnectStringPrefix

    protected String getConnectStringPrefix()

Description copied from class: `UnregisteredDriver`
Returns the prefix of the connect string that this driver will recognize as its own. For example, "jdbc:calcite:".

Specified by:
  `getConnectStringPrefix` in class `UnregisteredDriver`

#### createDriverVersion

    protected DriverVersion createDriverVersion()

Description copied from class: `UnregisteredDriver`
Creates an object describing the name and version of this driver. Called from the driver constructor.

Specified by:
  `createDriverVersion` in class `UnregisteredDriver`

#### getConnectionProperties

    protected Collection<ConnectionProperty> getConnectionProperties()

Description copied from class: `UnregisteredDriver`
Returns the connection properties supported by this driver.

Overrides:
  `getConnectionProperties` in class `UnregisteredDriver`

#### createMeta

    public Meta createMeta(AvaticaConnection connection)

Description copied from class: `UnregisteredDriver`
Creates a service handler that will give connections from this Driver their behavior.

Specified by:
  `createMeta` in class `UnregisteredDriver`

#### createKerberosUtility

    KerberosConnection createKerberosUtility(ConnectionConfig config)

#### createService

    Service createService(AvaticaConnection connection,
                          ConnectionConfig config)

Creates a `Service` with the given `AvaticaConnection` and configuration.

Parameters:
  `connection` - The `AvaticaConnection` to use.
  `config` - Configuration properties
Returns:
  A Service implementation.

#### getHttpClient

    AvaticaHttpClient getHttpClient(AvaticaConnection connection,
                                    ConnectionConfig config)

Creates the HTTP client that communicates with the Avatica server.

Parameters:
  `connection` - The `AvaticaConnection`.
  `config` - The configuration.
Returns:
  An `AvaticaHttpClient` implementation.

#### connect

    public Connection connect(String url,
                              Properties info)
                       throws SQLException

Specified by:
  `connect` in interface `Driver`
Overrides:
  `connect` in class `UnregisteredDriver`
Throws:
  `SQLException`

#### getSerialization

    Driver.Serialization getSerialization(ConnectionConfig config)